;
; Desktop Doodle 1.0.0
; Created by: Chris Vega
;
; This source-code is provided "as is" without warranty of any kind.
; The author disclaims any damages resulting from misuse of this program.
; The author grants you to use this source code without modifications.
;
; 2006 Copyright by Chris Vega
;
;
; AboutBox uses Vortex's ImageLib to display JPEG from resource.
; see ImageLib.inc for the ImageLib's readme.

.486
.model flat, stdcall

option proc: private

include windows.inc
include MsgCrack.inc

include user32.inc
include kernel32.inc
include gdi32.inc
include comdlg32.inc
include shell32.inc
include comctl32.inc
include ole32.inc
include imagelib\image.inc

includelib user32.lib
includelib kernel32.lib
includelib gdi32.lib
includelib comdlg32.lib
includelib shell32.lib
includelib comctl32.lib
includelib ole32.lib
includelib imagelib\image.lib
includelib oleaut32.lib

; -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
; Structures
; -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
tagDRAWITEMSTRUCT 	struct
	CtlType       	dd ?
	CtlID         	dd ?
	itemID        	dd ?
	itemAction    	dd ?
	itemState     	dd ?
	hwndItem      	dd ?
	hDC          	dd ?
	rcItem        	RECT <>
	itemData      	dd ?
tagDRAWITEMSTRUCT	ends

; -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
; Prototypes
; -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=

WinMain 	proto :HINSTANCE, :HINSTANCE, :LPSTR, :dword
WndProc		proto :HWND, :UINT, :WPARAM, :LPARAM
AboutProc	proto :HWND, :UINT, :WPARAM, :LPARAM
SetPen		proto
BeginPlotting	proto :HWND, :dword, :dword
EndPlotting	proto :dword
PlotPoint	proto :dword, :dword

; -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
; Local macros
; -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
option dotname

.handle_WM_NOTIFYDOODLE macro in_hWnd, in_lParam, in_wParam, addr_handler
	push	in_lParam
	push	in_hWnd
	call	addr_handler
endm

; return with value in eax
return macro value
	if value eq 0
		xor	eax, eax
	else
		mov	eax, value
	endif
	ret
endm

; invoke a function and return value
func macro params:vararg
	invoke	params
	exitm	<eax>
endm

; indirectly set value to var using the stack
set macro var, value
	push	value
	pop		var
endm

; -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
; Constants
; -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
.const
	WM_NOTIFYDOODLE	= 12345

; -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
; Uninitialize data
; -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
.data?
align 4
notify		NOTIFYICONDATA <>
hBmp		dd ?
hdcCanvas	HDC ?
hpen 		HPEN ?
hmenu 		HMENU ?
hxmenu 		HMENU ?
hfont 		HFONT ?
buffer		db 1024 dup (?)
hdlg		dd ?

; -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
; Initialized data
; -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
.data
align 4
wname 		db "Desktop Doodle by Chris Vega", 0
NoDrawing 	BOOL TRUE
activePlot 	BOOL FALSE

p 		POINT <0,0>
acrCustClr 	dd 00ff00ffh, 00ff0000h, 00ffff00h, 0000ff00h, 0000ffffh, 000000ffh
                dd 00800080h, 00800000h, 00808000h, 00008000h, 00008080h, 00000080h
                dd 00000000h, 00c0c0c0h, 00808080h, 00ffffffh
lgfont		LOGFONT <14, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, "Microsoft Sans Serif">
cur_color 	COLORREF 00008000h
cur_width 	dd 4
i		dd 0
j		dd 0

cls 		db "Chris.Vega.Desktop.Doodle", 0
hInstance	dd 0

; -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
; Entry-point
; -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
.code
start:
	mov	hInstance, func(GetModuleHandle, NULL)	
	invoke	WinMain, hInstance, NULL, NULL, SW_MAXIMIZE
	
	invoke	ExitProcess, 0

; -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
; WinMain
; -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
WinMain proc uses edi esi hInst:HINSTANCE,\
             hPrevInst:HINSTANCE,\
             CmdLine:LPSTR,\
             CmdShow:dword

	local	msg:MSG
	local	hWnd:HWND
	local	wc:WNDCLASS
	local	ohWnd:HWND
	
	set	hInstance, hInst

	; This is a single instance program
	mov	ohWnd, func(FindWindow, offset cls, NULL)
	cmp	ohWnd, 0
	je	@f
	invoke	ShowWindow, ohWnd, SW_MAXIMIZE
	invoke	SetForegroundWindow, ohWnd
	ret
	
	@@:
	mov	wc.style, CS_OWNDC or CS_DBLCLKS
	mov	wc.lpfnWndProc, offset WndProc
	mov	wc.cbClsExtra, 0
	mov	wc.cbWndExtra, 0
	set	wc.hInstance, hInstance
	mov	wc.hIcon, func(LoadIcon, hInstance, 2002)
	mov	wc.hCursor, func(LoadCursor, hInstance, 3332)
	mov	wc.hbrBackground, 0
	mov	wc.lpszMenuName, NULL
	mov	wc.lpszClassName, offset cls
    
	invoke	RegisterClass, addr wc
	.if !eax
		return	1
	.endif

	mov	hfont, func(CreateFontIndirect, offset lgfont)
	mov	hWnd, func(CreateWindowEx, WS_EX_TRANSPARENT or WS_EX_TOPMOST or WS_EX_TOOLWINDOW, offset cls, offset wname, WS_POPUP or WS_VISIBLE, 0, 0, 1, 1, NULL, NULL, hInst, 0)
	invoke	ShowWindow, hWnd, SW_MAXIMIZE
	invoke 	UpdateWindow, hWnd
	
	mov	notify.cbSize, sizeof NOTIFYICONDATA
	mov	ecx, 29
	mov	edi, offset notify.szTip
	mov	esi, offset wname
	rep	movsb
	mov	notify.hIcon, func(LoadIcon, hInst, 2002)
	set	notify.hwnd, hWnd
	mov	notify.uID, 12345
	mov	notify.uFlags, NIF_MESSAGE or NIF_ICON or NIF_TIP
	mov	notify.uCallbackMessage, WM_NOTIFYDOODLE

	.while TRUE
    		invoke	GetMessage, addr msg, hWnd, 0, 0
    		.break .if eax!=TRUE
       		invoke	TranslateMessage, addr msg
        	invoke	DispatchMessage, addr msg
	.endw
	
	invoke	DeleteObject, hfont
	invoke	Shell_NotifyIcon, NIM_DELETE, addr notify
	
	ret
WinMain endp


; -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
; Helper functions
; -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
SetPen proc
	.if hdcCanvas!=NULL
		mov	hpen, func(CreatePen, 0, cur_width, cur_color)
		invoke	SelectObject, hdcCanvas, hpen
	.endif

	ret
SetPen endp


BeginPlotting proc hWnd:HWND, x:dword, y:dword
	mov	activePlot, TRUE
	mov	hdcCanvas, func(GetWindowDC, hWnd)
	invoke	SetPen
	invoke	MoveToEx, hdcCanvas, x, y, NULL
	
	ret
BeginPlotting endp


EndPlotting proc hWnd:HWND
	.if activePlot==TRUE
		mov	activePlot, FALSE
		invoke	DeleteObject, hpen
		invoke	ReleaseDC, hWnd, hdcCanvas
	.endif
	
	ret
EndPlotting endp


PlotPoint proc x:dword, y:dword
	.if hdcCanvas!=NULL
		invoke	LineTo, hdcCanvas, x, y
		mov	NoDrawing, FALSE
	.endif
	ret
PlotPoint endp

; -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
; Message handlers
; -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
AboutProc proc hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
	local hdcabout:HDC
	local hOld:DWORD
	local memDC:DWORD
	local ps:PAINTSTRUCT
	local abtbrush:HBRUSH
	
	mov	eax, uMsg
	.if eax==WM_INITDIALOG
		invoke	CoInitialize, 0
		invoke	BitmapFromResource, hInstance, 2006	
		mov 	hBmp, eax
		invoke	 SetWindowText, hWnd, addr wname
		jmp	dlgmsgproc
	.elseif eax==WM_PAINT			
		invoke 	BeginPaint, hWnd, addr ps
		mov 	hdcabout, eax
		
		invoke 	CreateCompatibleDC, hdcabout
		mov 	memDC, eax
		    
		invoke 	SelectObject, memDC, hBmp
		mov 	hOld, eax

		invoke 	BitBlt, hdcabout, 0, 0, 326, 184, memDC, 0, 0, SRCCOPY
		
		invoke	SelectObject, hdcabout, hOld
		invoke	DeleteDC, memDC
		
		invoke 	EndPaint,hWnd, addr ps
		jmp	dlgmsgproc
	.elseif eax==WM_LBUTTONDOWN
		invoke	EndDialog, hWnd, 0
		jmp	dlgmsgproc
	.elseif eax==WM_CLOSE
		invoke	DeleteObject, hBmp
		invoke	CoUninitialize
		invoke	EndDialog, hWnd, 0
		jmp	dlgmsgproc
	.else
		mov	eax, FALSE
		ret
	.endif
	
	dlgmsgproc:
	mov	eax, TRUE
	ret
AboutProc endp

ShowAbout proc hWnd:HWND
	invoke	DialogBoxParam, hInstance, addr cls, hWnd, addr AboutProc, 0
	ret
ShowAbout endp

WndProc proc hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
	.handle_msg_begin
		.handle_msg WM_DESTROY, WmDestroy
		.handle_msg WM_RBUTTONDOWN, WmRButtonDown
		.handle_msg WM_COMMAND, WmCommand
		.handle_msg WM_LBUTTONDOWN, WmLButtonDown
		.handle_msg WM_LBUTTONUP, WmLButtonUp
		.handle_msg WM_MOUSEMOVE, WmMouseMove
		.handle_msg WM_KEYDOWN, WmKey
		.handle_msg WM_MEASUREITEM, WmMeasureItem
		.handle_msg WM_DRAWITEM, WmDrawItem
		.handle_msg WM_NOTIFYDOODLE, NotifyEvent
	.handle_msg_end
	
	invoke	DefWindowProc, hWnd, uMsg, wParam, lParam
	ret
WndProc endp

WmCommand proc hWnd:HWND, id:dword, hwndCtl:HWND, codeNotify:dword
	local	cc:CHOOSECOLOR
	
	mov		eax, id
	
	.if eax==50730
		jmp	colorfromhere
	.elseif eax==50731
		jmp	colorfromhere
	.elseif eax==50732
		jmp	colorfromhere
	.elseif eax==50733
		jmp	colorfromhere
	.elseif eax==50734
		jmp	colorfromhere
	.elseif eax==50735
		jmp	colorfromhere
	.elseif eax==50736
		jmp	colorfromhere
	.elseif eax==50737
		jmp	colorfromhere
	.elseif eax==50738
		jmp	colorfromhere
	.elseif eax==50739
		jmp	colorfromhere
	.elseif eax==50740
		jmp	colorfromhere
	.elseif eax==50741
		jmp	colorfromhere
	.elseif eax==50742
		jmp	colorfromhere
	.elseif eax==50743
		jmp	colorfromhere
	.elseif eax==50744
		jmp	colorfromhere
	.elseif eax==50745
		colorfromhere:
		mov	eax, id
		sub	eax, 50730
		shl	eax, 2
		add	eax, offset acrCustClr
		set	cur_color, [eax]
		call	SetPen
	.elseif eax==3330
		jmp	checkcuritem
	.elseif eax==3331
		jmp	checkcuritem
	.elseif eax==3332
		jmp	checkcuritem
	.elseif eax==3333
		jmp	checkcuritem
	.elseif eax==3334
		jmp	checkcuritem
	.elseif eax==3335
		jmp	checkcuritem
	.elseif eax==3336
		jmp	checkcuritem
	.elseif eax==3337
		jmp	checkcuritem
	.elseif eax==3338
		checkcuritem:
		invoke	LoadCursor, hInstance, id
		invoke	SetClassLong, hWnd, GCL_HCURSOR, eax
			
		mov	i, 3330

		push	edx
		forloopcur:
			
		xor	edx, edx
		mov	eax, i
		sub	eax, id
		jnz	mf_okcur
		add	edx, 8
		mf_okcur:
		invoke	CheckMenuItem, hmenu, i, edx
			
		add	i, 1
		cmp	i, 3339
		jbe	forloopcur
		pop	edx
	.elseif eax==1231
		mov	cur_width, 1
		jmp	checkmenuitem
	.elseif eax==1232
		mov	cur_width, 2
		jmp	checkmenuitem
	.elseif eax==1233
		mov	cur_width, 4
		jmp	checkmenuitem
	.elseif eax==1234
		mov	cur_width, 8
		jmp	checkmenuitem
	.elseif eax==1235
		mov	cur_width, 16
		jmp	checkmenuitem
	.elseif eax==1236
		mov	cur_width, 24
		jmp	checkmenuitem
	.elseif eax==1237
		mov	cur_width, 32
		jmp	checkmenuitem
	.elseif eax==1238
		mov	cur_width, 48
		jmp	checkmenuitem
	.elseif eax==1239
		mov		cur_width, 64
		checkmenuitem:
		mov		i, 1231
			
		forloop:
		push	ecx
		push	edx
			
		mov	j, MF_UNCHECKED
		mov	eax, i
		sub	eax, id
		jnz	mf_ok
		mov	j, MF_CHECKED
		mf_ok:
		invoke	CheckMenuItem, hmenu, i, j
			
		pop	edx
		pop	ecx
			
		add	i, 1
		cmp	i, 1239
		jbe	forloop
	.elseif eax==1030
		invoke	ShowWindow, hWnd, SW_HIDE
		invoke	ShowWindow, hWnd, SW_MAXIMIZE
	.elseif eax==5699 
		mov	cc.lStructSize, sizeof CHOOSECOLOR
		set	cc.hwndOwner, hWnd
		mov	cc.lpCustColors, offset acrCustClr
		set	cc.rgbResult, cur_color
		mov	cc.Flags, CC_FULLOPEN or CC_RGBINIT
		invoke	ChooseColor, addr cc
			
		.if eax==TRUE
			set	cur_color, cc.rgbResult 
		.endif
	.elseif eax==1028
		invoke	Shell_NotifyIcon, NIM_DELETE, addr notify
		invoke	ShowWindow, hWnd, SW_MAXIMIZE
	.elseif eax==1022
		invoke	EndPlotting, hWnd
		invoke	ShowWindow, hWnd, SW_HIDE
		invoke	Shell_NotifyIcon, NIM_ADD, addr notify
	.elseif eax==1024
		push	hWnd
		call	ShowAbout
	.elseif eax==1026
		invoke	PostQuitMessage, 0
	.endif
	ret
WmCommand endp

WmRButtonDown proc hWnd:HWND, fDoubleClick:BOOL, x:dword, y:dword, keyFlags:dword
	.if hmenu==NULL
		mov	hmenu, func(LoadMenu, hInstance, 1001)
	.endif
	invoke	EndPlotting, hWnd
	invoke	TrackPopupMenuEx, func(GetSubMenu, hmenu, 0), 0, x, y, hWnd, NULL 
	ret
WmRButtonDown endp

WmLButtonDown proc hWnd:HWND, fDoubleClick:BOOL, x:dword, y:dword, keyFlags:dword
	invoke	BeginPlotting, hWnd, x, y
	ret
WmLButtonDown endp

WmLButtonUp proc hWnd:HWND, x:dword, y:dword, keyFlags:dword
	invoke	EndPlotting, hWnd
	ret
WmLButtonUp endp

WmMouseMove proc hWnd:HWND, x:dword, y:dword, keyFlags:dword
	.if activePlot==TRUE
		invoke	PlotPoint, x, y
	.endif
	ret
WmMouseMove endp

WmDestroy proc hWnd:HWND
    invoke	PostQuitMessage, 0
    ret
WmDestroy endp

NotifyEvent proc hWnd:HWND, message:dword
	local	pos:POINT
	.if hxmenu==NULL 
		mov	hxmenu, func(LoadMenu, hInstance, 1002)
	.endif
	
	mov	eax, message
	
	.if eax==WM_LBUTTONDBLCLK
		invoke	Shell_NotifyIcon, NIM_DELETE, addr notify
		invoke	ShowWindow, hWnd, SW_MAXIMIZE
	.elseif eax==WM_RBUTTONUP
		jmp ShowNotifyShortcut
	.elseif eax==WM_RBUTTONDOWN
		jmp ShowNotifyShortcut
	.elseif eax==WM_CONTEXTMENU		
		ShowNotifyShortcut:
		invoke	GetCursorPos, addr pos
		invoke	TrackPopupMenuEx, func(GetSubMenu, hxmenu, 0), 0, pos.x, pos.y, hWnd, NULL
	.endif
	ret
NotifyEvent endp

WmKey proc hWnd:HWND, vk:dword, fDown:BOOL, cRepeat:dword, flags:dword
	local	cc:CHOOSECOLOR
	local	ptx:POINT
	
	mov	eax, vk
	.if eax==VK_Q
		mov	i, 0
		jmp	colorbyindex
	.elseif eax==VK_W
		mov	i, 1
		jmp	colorbyindex
	.elseif eax==VK_E
		mov	i, 2
		jmp	colorbyindex
	.elseif eax==VK_R
		mov	i, 3
		jmp	colorbyindex
	.elseif eax==VK_T
		mov	i, 4
		jmp	colorbyindex
	.elseif eax==VK_Y
		mov	i, 5
		jmp	colorbyindex
	.elseif eax==VK_A
		mov	i, 6
		jmp	colorbyindex
	.elseif eax==VK_S
		mov	i, 7
		jmp	colorbyindex
	.elseif eax==VK_D
		mov	i, 8
		jmp	colorbyindex
	.elseif eax==VK_F
		mov	i, 9
		jmp	colorbyindex
	.elseif eax==VK_G
		mov	i, 10
		jmp	colorbyindex
	.elseif eax==VK_Z
		mov	i, 11
		jmp	colorbyindex
	.elseif eax==VK_X
		mov	i, 12
		jmp	colorbyindex
	.elseif eax==VK_C
		mov	i, 13
		jmp	colorbyindex
	.elseif eax==VK_V
		mov	i, 14
		jmp	colorbyindex
	.elseif eax==VK_B
		mov	i, 15
		colorbyindex:
		mov	eax, i
		shl	eax, 2
		add	eax, offset acrCustClr
		set	cur_color, [eax]
		call	SetPen
	.elseif eax==VK_ESCAPE
		invoke	GetKeyState, VK_SHIFT
		and	eax, 100h
		jz 	@f
		invoke	DestroyWindow, hWnd
		invoke	PostQuitMessage, 0
		jmp 	WmKey_Return
		@@:
		invoke	EndPlotting, hWnd
		invoke	ShowWindow, hWnd, SW_HIDE
		invoke	Shell_NotifyIcon, NIM_ADD, addr notify
	.elseif eax=='1'
		jmp	@key1
	.elseif eax==VK_NUMPAD1
		@key1:
		mov	j, 1
		mov	cur_width, 1
		jmp	checkmenuitem2
	.elseif eax=='2'
		jmp	@key2
	.elseif eax==VK_NUMPAD2
		@key2:
		mov	j, 2
		mov	cur_width, 2
		jmp	checkmenuitem2
	.elseif eax=='3'
		jmp	@key3
	.elseif eax==VK_NUMPAD3
		@key3:
		mov	j, 3
		mov	cur_width, 4
		jmp	checkmenuitem2
	.elseif eax=='4'
		jmp	@key4
	.elseif eax==VK_NUMPAD4
		@key4:
		mov	j, 4
		mov	cur_width, 8
		jmp	checkmenuitem2
	.elseif eax=='5'
		jmp	@key5
	.elseif eax==VK_NUMPAD5
		@key5:
		mov	j, 5
		mov	cur_width, 16
		jmp	checkmenuitem2
	.elseif eax=='6'
		jmp	@key6
	.elseif eax==VK_NUMPAD6
		@key6:
		mov	j, 6
		mov	cur_width, 24
		jmp	checkmenuitem2
	.elseif eax=='7'
		jmp	@key7
	.elseif eax==VK_NUMPAD7
		@key7:
		mov	j, 2
		mov	cur_width, 32
		jmp	checkmenuitem2
	.elseif eax=='8'
		jmp	@key8
	.elseif eax==VK_NUMPAD8
		@key8:
		mov	j, 8
		mov	cur_width, 48
		jmp	checkmenuitem2
	.elseif eax=='9'
		jmp	@key9
	.elseif eax==VK_NUMPAD9
		@key9:
		mov	j, 9
		mov	cur_width, 64
		jmp	checkmenuitem2
	.elseif eax=='0'
		jmp	@clear
	.elseif eax==VK_NUMPAD0
		jmp	@clear
	.elseif eax==VK_BACK
		@clear:
		.if NoDrawing!=TRUE
			invoke	ShowWindow, hWnd, SW_HIDE
			invoke	ShowWindow, hWnd, SW_MAXIMIZE
			mov		NoDrawing, TRUE
		.endif
	.elseif eax==VK_RETURN
		jmp	@keycolor
	.elseif eax==VK_SPACE
		@keycolor:
		mov	cc.lStructSize, sizeof CHOOSECOLOR
		set	cc.hwndOwner, hWnd
		mov	cc.lpCustColors, offset acrCustClr
		set	cc.rgbResult, cur_color
		set	cc.Flags, CC_FULLOPEN or CC_RGBINIT
		invoke	ChooseColor, addr cc
				
		.if eax==TRUE
			set	cur_color, cc.rgbResult
			call	SetPen
		.endif
	.elseif eax==VK_F1
		mov	j, 3330
		jmp	checkcuritem2
	.elseif eax==VK_F2
		mov	j, 3331
		jmp	checkcuritem2
	.elseif eax==VK_F3
		mov	j, 3332
		jmp	checkcuritem2
	.elseif eax==VK_F4
		mov	j, 3333
		jmp	checkcuritem2
	.elseif eax==VK_F5
		mov	j, 3334
		jmp	checkcuritem2
	.elseif eax==VK_F6
		mov	j, 3335
		jmp	checkcuritem2
	.elseif eax==VK_F7
		mov	j, 3336
		jmp	checkcuritem2
	.elseif eax==VK_F8
		mov	j, 3337
		jmp	checkcuritem2
	.elseif eax==VK_F9
		mov		j, 3338
		checkcuritem2:
		invoke	LoadCursor, hInstance, j
		invoke	SetClassLong, hWnd, GCL_HCURSOR, eax
		invoke	UpdateWindow, hWnd
		invoke	GetCursorPos, addr ptx
		invoke	SetCursorPos, ptx.x, ptx.y
			
		mov	i, 3330
			
		push	edx
			
		forloopcur2:			
		xor	edx, edx
		mov	eax, i
		sub	eax, j
		jnz	mf_okcur
		add	edx, 8
			
		mf_okcur:
		invoke	CheckMenuItem, hmenu, i, edx
			
		add	i, 1
		cmp	i, 3339
		jbe	forloopcur2
			
		pop	edx
	.endif
	
	WmKey_Return:
	ret
	
	; Set the checked menu based on key pressed
	checkmenuitem2:
	call	SetPen
	push	edx
	mov	i, 1231
	forloop2:
	xor	edx, edx
	mov	eax, i
	mov	ecx, 1230
	add	ecx, j
	sub	eax, ecx
	jnz	mf_ok2
	add	edx, 8
	mf_ok2:
	invoke	CheckMenuItem, hmenu, i, edx
	
	add	i, 1
	cmp	i, 1239
	jbe	forloop2
	pop	edx
	ret
WmKey endp


WmMeasureItem proc uses ebx edi hWnd:HWND, lpMeasureItem:dword
	local	hdc2:HDC
	local	__tsize:SIZEL

	mov	ebx, lpMeasureItem
	assume	ebx: ptr MEASUREITEMSTRUCT
	
	invoke	IsWindowVisible, hWnd
	.if eax==TRUE
		invoke	GetMenuString, hmenu, [ebx].itemID, addr buffer, 1024, MF_BYCOMMAND
	.else
		invoke	GetMenuString, hxmenu, [ebx].itemID, addr buffer, 1024, MF_BYCOMMAND
	.endif
	mov	i, eax

	mov	hdc2, func(GetDC, hWnd)
	invoke	SelectObject, hdc2, hfont
	invoke	GetTextExtentPoint32, hdc2, addr buffer, i, addr __tsize
	
	add	__tsize.y, 8
	push	__tsize.y
	pop	[ebx].itemHeight
	
	add	__tsize.x, 38
	push	__tsize.x
	pop	[ebx].itemWidth
	
	invoke	ReleaseDC, hWnd, hdc2
	ret
WmMeasureItem endp

WmDrawItem proc hWnd:HWND, lpDrawItem:dword

	; Reserve the rectangles we are goin to use
	local	mrtext:RECT
	local	mrmark:RECT
	
	; Reserve pen and brush for the whole process of drawing menu	
	local	hmpen:HPEN
	local	hmbrush:HBRUSH
	local	hmopen:HPEN
	local	hmobrush:HBRUSH
	local	hmtbrush:HBRUSH
	
	; Other local variables
	local	hb:HICON
	local	hofont:HFONT
	
	; Get the data passed by WM_DRAWITEM message
	mov	ebx, lpDrawItem
	assume	ebx: ptr tagDRAWITEMSTRUCT

	; Extract the menu text
	invoke	IsWindowVisible, hWnd
	.if eax==TRUE
		invoke	GetMenuString, hmenu, [ebx].itemID, addr buffer, 1024, MF_BYCOMMAND
	.else
		invoke	GetMenuString, hxmenu, [ebx].itemID, addr buffer, 1024, MF_BYCOMMAND
	.endif
	
	; Set the menutext length to general purpose variable
	mov	i, eax
	
	; Save the rectangle of the menu	
	set	mrmark.left, [ebx].rcItem.left
	set	mrmark.top, [ebx].rcItem.top
	set	mrmark.bottom, [ebx].rcItem.bottom
	
	push	SM_CXMENUCHECK
	call	GetSystemMetrics
	mov	mrmark.right, eax
	add	mrmark.right, 8
	
	set	mrtext.left, mrmark.right
	set	mrtext.top, [ebx].rcItem.top	
	set	mrtext.right, [ebx].rcItem.right
	set	mrtext.bottom, [ebx].rcItem.bottom
	
	; Color the marker side of the menu
	mov	hmbrush, func(CreateSolidBrush, 00d1d8dbh)
	invoke	FillRect, [ebx].hDC, addr mrmark, hmbrush
	invoke	DeleteObject, hmbrush

	; Color the text side of the menu	
	mov		hmbrush, func(CreateSolidBrush, 00f7f8f9h)
	invoke	FillRect, [ebx].hDC, addr mrtext, hmbrush
	invoke	DeleteObject, hmbrush
	
	; Adjust the rectangles
	add	mrtext.top, 1
	sub	mrtext.bottom, 2	
	sub	mrtext.right, 3
	add	mrmark.top, 1
	sub	mrmark.bottom, 2	
	add	mrmark.left, 2
	
	; Are we painting selected menu?
	invoke	SetBkColor, [ebx].hDC, 00f7f8f9h
	mov	hmbrush, func(CreateSolidBrush, 00d1d8dbh)
	mov	hofont, func(SelectObject, [ebx].hDC, hfont)
	mov	eax, [ebx].itemState
	and	eax, ODS_SELECTED
	jz	@f

	mov	hmbrush, func(CreateSolidBrush, 00d2bdb6h)
	invoke	FillRect, [ebx].hDC, addr mrmark, hmbrush
	invoke	FillRect, [ebx].hDC, addr mrtext, hmbrush
	invoke	DeleteObject, hmbrush
	
	mov	hmpen, func(CreatePen, 0, 1, 006a240ah)
	mov	hmopen, func(SelectObject, [ebx].hDC, hmpen)
	
	invoke	MoveToEx, [ebx].hDC, mrmark.left, mrmark.top, NULL
	invoke	LineTo, [ebx].hDC, mrtext.right, mrtext.top
	invoke	LineTo, [ebx].hDC, mrtext.right, mrtext.bottom
	invoke	LineTo, [ebx].hDC, mrmark.left, mrmark.bottom
	invoke	LineTo, [ebx].hDC, mrmark.left, mrmark.top
	invoke	DeleteObject, hmpen
	mov		hmpen, func(CreatePen, 0, 1, 00878889h)
	invoke	SelectObject, [ebx].hDC, hmpen
	push	i
	set	i, mrmark.left
	add	i, 1
	set	j, mrmark.bottom
	add	j, 1
	invoke	MoveToEx, [ebx].hDC, i, j, NULL
	set	i, mrtext.right
	add	i, 1
	invoke	LineTo, [ebx].hDC, i, j
	set	j, mrtext.top
	add	j, 1
	invoke	LineTo, [ebx].hDC, i, j
	pop	i
	
	invoke	SelectObject, [ebx].hDC, hmopen
	invoke	DeleteObject, hmpen
	
	invoke	SetBkColor, [ebx].hDC, 00d2bdb6h
	invoke	SetTextColor, [ebx].hDC, 00ff0000h	
	mov	hmbrush, func(CreateSolidBrush, 00d2bdb6h)

	; Draw the text for the menu
	@@:	
	add	mrtext.left, 4
	invoke	DrawText, [ebx].hDC, addr buffer, i, addr mrtext, DT_SINGLELINE or DT_VCENTER
	invoke	SelectObject, [ebx].hDC, hfont
	
	mov	eax, [ebx].itemState
	and	eax, ODS_CHECKED
	jz	@f
	
	mov	hb, func(LoadIcon, hInstance, 2003)
	add	mrmark.left, 2
	add	mrmark.top, 2	
	invoke	DrawIconEx, [ebx].hDC, mrmark.left, mrmark.top, eax, 16, 16, NULL, hmbrush, DI_NORMAL

	@@:
	mov	eax, [ebx].itemID
	cmp 	eax, 50700
	jb	@f
	mov	eax, [ebx].itemID
	sub	eax, 50730
	shl	eax, 2
	add	eax, offset acrCustClr
	mov	hmtbrush, func(CreateSolidBrush, [eax])
	add	mrmark.top, 4
	add	mrmark.left, 4
	sub	mrmark.right, 4
	sub	mrmark.bottom, 4
	invoke	FillRect, [ebx].hDC, addr mrmark, hmtbrush
	sub	mrmark.top, 4
	sub	mrmark.left, 4
	add	mrmark.right, 4
	add	mrmark.bottom, 4
	invoke	DeleteObject, hmtbrush
	
	@@:
	mov	eax, [ebx].itemID
	cmp 	eax, 20000
	jnz	@f
	mov	eax, mrmark.bottom
	sub	eax, mrmark.top
	shr	eax, 1
	add	eax, mrmark.top
	add	eax, 1
	mov	i, eax
	mov	hmpen, func(CreatePen, 0, 1, 008e8e8eh)
	invoke	SelectObject, [ebx].hDC, hmpen
	invoke	MoveToEx, [ebx].hDC, mrmark.left, i, NULL
	invoke	LineTo, [ebx].hDC, mrtext.right, i
	invoke	SelectObject, [ebx].hDC, hmopen
	invoke	DeleteObject, hmpen
	
	@@:
	mov	eax, [ebx].itemID
	cmp 	eax, 1020
	jnz	@f
	mov	hb, func(LoadIcon, hInstance, 2004)
	add	mrmark.left, 2
	add	mrmark.top, 2	
	invoke	DrawIconEx, [ebx].hDC, mrmark.left, mrmark.top, eax, 16, 16, NULL, NULL, DI_NORMAL

	@@:	
	cmp 	eax, 1022
	jnz	@f
	mov	hb, func(LoadIcon, hInstance, 2005)
	add	mrmark.left, 2
	add	mrmark.top, 2	
	invoke	DrawIconEx, [ebx].hDC, mrmark.left, mrmark.top, eax, 16, 16, NULL, hmbrush, DI_NORMAL

	@@:	
	cmp 	eax, 1024
	jnz	@f
	mov	hb, func(LoadIcon, hInstance, 2008)
	add	mrmark.left, 2
	add	mrmark.top, 2	
	invoke	DrawIconEx, [ebx].hDC, mrmark.left, mrmark.top, eax, 16, 16, NULL, hmbrush, DI_NORMAL
	
	@@:	
	cmp 	eax, 1028
	jnz	@f
	mov	hb, func(LoadIcon, hInstance, 2006)
	add	mrmark.left, 2
	add	mrmark.top, 2	
	invoke	DrawIconEx, [ebx].hDC, mrmark.left, mrmark.top, eax, 16, 16, NULL, hmbrush, DI_NORMAL
	
	@@:	
	cmp 	eax, 1026
	jnz	@f
	mov	hb, func(LoadIcon, hInstance, 2007)
	add	mrmark.left, 2
	add	mrmark.top, 2	
	invoke	DrawIconEx, [ebx].hDC, mrmark.left, mrmark.top, eax, 16, 16, NULL, hmbrush, DI_NORMAL
	
	@@:
	invoke	DeleteObject, hmbrush
	ret
WmDrawItem endp

end start